=== modified file 'src/Widgets/ModemInfoBox.vala'
--- src/Widgets/ModemInfoBox.vala	2016-10-12 15:53:11 +0000
+++ src/Widgets/ModemInfoBox.vala	2016-10-14 10:34:09 +0000
@@ -26,9 +26,8 @@
 
         private Gtk.Label ip4address;
         private Gtk.Label ip6address;
-        private Gtk.Label mask;
-        private Gtk.Label router;
-        private Gtk.Label broadcast;
+        private Gtk.Label default_route;
+        private Gtk.Label dns;
         private Gtk.Label sent;
         private Gtk.Label received;
 
@@ -93,26 +92,19 @@
             ip6address.no_show_all = true;
             ip6address.xalign = 0;
 
-            var mask_head = new Gtk.Label (_("Subnet mask:"));
-            mask_head.halign = Gtk.Align.END;
-
-            mask = new Gtk.Label ("");
-            mask.selectable = true;
-            mask.xalign = 0;
-
-            var router_head = new Gtk.Label (_("Router:"));
-            router_head.halign = Gtk.Align.END;
-
-            router = new Gtk.Label ("");
-            router.selectable = true;
-            router.xalign = 0;
-
-            var broadcast_head = new Gtk.Label (_("Broadcast:"));
-            broadcast_head.halign = Gtk.Align.END;
-
-            broadcast = new Gtk.Label ("");
-            broadcast.selectable = true;
-            broadcast.xalign = 0;
+            var default_route_head = new Gtk.Label (_("Default Route:"));
+            default_route_head.halign = Gtk.Align.END;
+
+            default_route = new Gtk.Label ("");
+            default_route.selectable = true;
+            default_route.xalign = 0;
+
+            var dns_head = new Gtk.Label (_("DNS:"));
+            dns_head.halign = Gtk.Align.END;
+
+            dns = new Gtk.Label ("");
+            dns.selectable = true;
+            dns.xalign = 0;
 
             attach (ip4address_head, 0, 0);
             attach_next_to (ip4address, ip4address_head, Gtk.PositionType.RIGHT);
@@ -120,16 +112,11 @@
             attach_next_to (ip6address_head, ip4address_head, Gtk.PositionType.BOTTOM);
             attach_next_to (ip6address, ip6address_head, Gtk.PositionType.RIGHT);
 
-            attach_next_to (mask_head, ip6address_head, Gtk.PositionType.BOTTOM);
-            attach_next_to (mask, mask_head, Gtk.PositionType.RIGHT);
-
-            attach_next_to (router_head, mask_head, Gtk.PositionType.BOTTOM);
-            attach_next_to (router, router_head, Gtk.PositionType.RIGHT);
-
-            attach_next_to (broadcast_head, router_head, Gtk.PositionType.BOTTOM);
-            attach_next_to (broadcast, broadcast_head, Gtk.PositionType.RIGHT);
-
-            attach_next_to (send_receive_grid, broadcast_head, Gtk.PositionType.BOTTOM, 4, 1);
+            attach_next_to (default_route_head, ip6address_head, Gtk.PositionType.BOTTOM);
+            attach_next_to (default_route, default_route_head, Gtk.PositionType.RIGHT);
+
+            attach_next_to (dns_head, default_route_head, Gtk.PositionType.BOTTOM);
+            attach_next_to (dns, dns_head, Gtk.PositionType.RIGHT);
 
             device.state_changed.connect (() => { 
                 update_status ();
@@ -150,6 +137,7 @@
             // Refresh IP4 info
             var ip4 = device.get_ip4_config ();
             if (ip4 != null) {
+            	ip4address.label = "";
                 int i = 1;
                 SList<NM.IP4Address> addresses = ip4.get_addresses ().copy ();
                 addresses.@foreach ((addr) => {
@@ -162,12 +150,18 @@
                     }
 
                     i++;
-                });         
+                });
+                default_route.label =  (ip4.get_gateway () ?? UNKNOWN_STR);
+                Array<uint32> dns_nameservers = ip4.get_nameservers ();
+                if (dns_nameservers != null ) {
+	                var dnsaddr = Posix.InAddr () { s_addr = dns_nameservers.index (0) };
+	                string dns_str = Posix.inet_ntoa (dnsaddr);
+	                dns.label =  (dns_str ?? UNKNOWN_STR);
+            	}
             } else {
                 ip4address.label = UNKNOWN_STR;
-                mask.label =  UNKNOWN_STR;
-                router.label = UNKNOWN_STR;
-                broadcast.label = UNKNOWN_STR;
+                default_route.label =  UNKNOWN_STR;
+                dns.label = UNKNOWN_STR;
             }
 
             var ip6 = device.get_ip6_config ();

=== modified file 'src/Widgets/ModemInterface.vala'
--- src/Widgets/ModemInterface.vala	2016-10-10 15:01:13 +0000
+++ src/Widgets/ModemInterface.vala	2016-10-14 10:34:09 +0000
@@ -49,7 +49,7 @@
 
             if (modem_info_box != null) {
                     string sent_bytes, received_bytes;
-                    this.get_activity_information (device.get_iface (), out sent_bytes, out received_bytes);
+                    this.get_activity_information (device.get_ip_iface (), out sent_bytes, out received_bytes);
                     modem_info_box.update_activity (sent_bytes, received_bytes);       
                 }
 

